Difference between revisions of "Uniform look for Qt and GTK applications"

From ArchWiki
Jump to: navigation, search
(Qt App..: Moved to own section)
(After system upgrade breeze icons are missing in GTK apps. Found solution here: https://bbs.archlinux.org/viewtopic.php?id=107465 This is second time I faced to this issue)
(42 intermediate revisions by 18 users not shown)
Line 5: Line 5:
 
[[ja:Qt と GTK アプリケーションの外観の統合]]
 
[[ja:Qt と GTK アプリケーションの外観の統合]]
 
[[ru:Uniform look for Qt and GTK applications]]
 
[[ru:Uniform look for Qt and GTK applications]]
[[uk:Uniform look for Qt and GTK applications]]
+
[[zh-hans:Uniform look for Qt and GTK applications]]
[[zh-cn:Uniform look for Qt and GTK applications]]
 
 
{{Related articles start}}
 
{{Related articles start}}
 
{{Related|GTK+}}
 
{{Related|GTK+}}
Line 22: Line 21:
  
 
You can choose various approaches:
 
You can choose various approaches:
 +
* Modify [[#Styles for both Qt and GTK+|GTK+ and Qt styles]] separately with the tools listed below for each toolkit and aim for choosing similarly looking themes (style, colors, icons, cursors, fonts).
 
* Use a special [[#Theme engines|theme engine]], which intermediates the modification of the other graphical toolkit to match your main toolkit.
 
* Use a special [[#Theme engines|theme engine]], which intermediates the modification of the other graphical toolkit to match your main toolkit.
* Modify [[#Styles for both Qt and GTK+|GTK+ and Qt styles]] separately with the tools listed below for each toolkit and aim for choosing similarly looking themes (style, colors, icons, cursors, fonts).
+
 
 +
== Styles for both Qt and GTK+ ==
 +
There are widget style sets available for the purpose of integration, where builds are written and provided for both Qt and GTK+, all major versions included. With these, you can have one look for all applications regardless of the toolkit they had been written with.
 +
 
 +
{{Tip|You may want to apply user defined styles to root applications, see [[GTK#Theme not applied to root applications]] and [[Qt#Theme not applied to root applications]].}}
 +
{{Note|1=Since version 3.16, GTK+ 3 [https://bbs.archlinux.org/viewtopic.php?pid=1518404#p1518404 does not support] non-CSS themes, hence previous solutions such as Oxygen-Gtk are [https://bugs.kde.org/show_bug.cgi?id=340288 no longer viable] options.}}
 +
 
 +
=== Breeze ===
 +
 
 +
Breeze is the default Qt style of KDE Plasma. It can be installed with the {{Pkg|breeze}} package for Qt5, the {{Pkg|breeze-kde4}} package for Qt4, and the {{Pkg|breeze-gtk}} package for GTK+ 2 and GTK+ 3.
 +
 
 +
Once installed, you can use one of the many [[GTK+#Configuration tools|GTK+ configuration tools]] to change the GTK+ theme.
 +
 
 +
=== Adwaita ===
 +
 
 +
Adwaita is the default GNOME theme. The GTK+ 3 version is included in the {{Pkg|gtk3}} package, while the GTK+ 2 version is in {{Pkg|gnome-themes-standard}}. [https://github.com/MartinBriza/adwaita-qt adwaita-qt] is a Qt port of the Adwaita theme. Unlike [[#QGtkStyle]], which mimics the GTK+ 2 theme, it provides a native Qt style made to look like the GTK+ 3 Adwaita. It can be [[install|installed]] with the {{AUR|adwaita-qt4}} and {{AUR|adwaita-qt5}} packages for the Qt 4 and 5 versions, respectively.
 +
 
 +
To set the Qt style as default:
 +
 
 +
* For Qt4, it can be enabled with ''Qt Configuration'' ({{ic|qtconfig-qt4}}), choose ''adwaita'' under ''Appearance > GUI Style''. Alternatively, edit the {{ic|/etc/xdg/Trolltech.conf}} (system-wide) or {{ic|~/.config/Trolltech.conf}} (user-specific) file:
 +
 
 +
{{hc|~/.config/Trolltech.conf|2=
 +
...
 +
[Qt]
 +
style=adwaita
 +
...
 +
}}
 +
 
 +
* For Qt 5, it can be enabled by setting the following [[Environment variables#Graphical applications|environment variable]]: {{ic|1=QT_STYLE_OVERRIDE=adwaita}}. Alternatively, use {{Pkg|qt5ct}} package. For more detailed instructions, see [[Qt#Configuration of Qt5 apps under environments other than KDE Plasma]].
  
 
== Theme engines ==
 
== Theme engines ==
Line 30: Line 58:
  
 
=== QGtkStyle ===
 
=== QGtkStyle ===
 +
 +
{{Note|QGtkStyle has been removed from {{Pkg|qt5-base}} 5.7.0 [https://github.com/qtproject/qtbase/commit/899a815414e95da8d9429a4a4f4d7094e49cfc55] and added to {{Pkg|qt5-styleplugins}} [https://github.com/qtproject/qtstyleplugins/commit/102da7d50231fc5723dba6e72340bef3d29471aa]}}
  
 
{{Warning|Depending on GTK+ 2 theme, this style may cause rendering issues such as transparent fonts or inconsistent widgets.}}
 
{{Warning|Depending on GTK+ 2 theme, this style may cause rendering issues such as transparent fonts or inconsistent widgets.}}
Line 46: Line 76:
 
}}
 
}}
  
* For Qt 5, it can be enabled by setting the following [[Environment variables#Graphical applications|environment variable]]: {{ic|1=QT_STYLE_OVERRIDE=GTK+}}.
+
* For Qt 5, it can be enabled by installing {{Pkg|qt5-styleplugins}} and setting the following [[Environment variables#Graphical applications|environment variable]]: {{ic|1=QT_QPA_PLATFORMTHEME=gtk2}}
 
 
For full uniformity, make sure that the configured [[GTK+#Themes|GTK+ theme]] supports both GTK+ 2 and GTK+ 3.
 
 
 
== Styles for both Qt and GTK+ ==
 
  
There are widget style sets available for the purpose of integration, where builds are written and provided for both Qt and GTK+, all major versions included. With these, you can have one look for all applications regardless of the toolkit they had been written with.
+
For full uniformity, make sure that the configured [[GTK+#Themes|GTK+ theme]] supports both GTK+ 2 and GTK+ 3. If your preferred theme has inconsistent rendering after configuring Qt to use GTK+2, install {{ic|gtk-theme-switch2}} and choose a theme.
  
{{Note|1=Since version 3.16, GTK+ 3 [https://bbs.archlinux.org/viewtopic.php?pid=1518404#p1518404 does not support] non-CSS themes, hence previous solutions such as Oxygen-Gtk are [https://bugs.kde.org/show_bug.cgi?id=340288 no longer viable] options.}}
+
=== QGnomePlatform ===
 
 
=== Breeze ===
 
 
 
Breeze is the default Qt style of KDE Plasma. It can be installed with the {{Pkg|breeze}} package for Qt5, the {{Pkg|breeze-kde4}} package for Qt4, and the {{Pkg|breeze-gtk}} package for GTK+ 2 and GTK+ 3.
 
 
 
Once installed, you can use one of the many [[GTK+#Configuration tools|GTK+ configuration tools]] to change the GTK+ theme.
 
 
 
=== Adwaita ===
 
  
Adwaita is the default GNOME theme. It can be installed with the {{Pkg|gnome-themes-standard}} package, which contains the GTK+ 2 and 3 themes. [https://github.com/MartinBriza/adwaita-qt adwaita-qt] is an unofficial Qt port of the Adwaita theme. Unlike [[#QGtkStyle]], which mimic the GTK+ 2 theme, it provides a native Qt style made to look like the GTK+ 3 Adwaita. It can be [[install|installed]] with the {{AUR|adwaita-qt5}} package for the Qt5 version, and {{AUR|adwaita-qt4}} for the Qt 4 version.
+
This Qt 5 platform theme applies the appearance settings of GNOME for Qt applications. It can be installed with the {{AUR|qgnomeplatform}} package or the {{AUR|qgnomeplatform-git}} package for the development version. It does not provide a Qt style itself, instead it requires a [[#Styles for both Qt and GTK+|style that support both Qt and GTK+]].
  
=== Qt Appearance ===
+
This platform theme is enabled automatically in GNOME since version 3.20. For other systems, it can be enabled by setting the following [[Environment variables#Graphical applications|environment variable]]: {{ic|1=QT_QPA_PLATFORMTHEME=qgnomeplatform}}.
To set a style as default, you can use {{Pkg|qt5ct}} for Qt 5, or {{ic|qtconfig-qt4}} (part of the {{Pkg|qt4}} package) for Qt 4.
 
  
 
== Tips and tricks ==
 
== Tips and tricks ==
 
=== KDE file dialogs for GTK+ applications ===
 
=== KDE file dialogs for GTK+ applications ===
 +
'''Chromium''' 
 +
At least for chromium installing {{ic|kdialog}} makes chromium used kde file dialog ( so `KGtk-wrapper` is not required )
  
{{Warning|Some GTK+ applications may not be compatible with KGtk-wrapper (e.g. [[Chromium]]), sometimes the wrapper makes the application crash (e.g. [[Firefox]]) and even other applications like [[KDM]] (when used with e.g. [[Thunderbird]]).}}
+
{{Warning|Some GTK+ applications may not be compatible with KGtk-wrapper (e.g. [[Chromium]]), sometimes the wrapper makes the application crash ([[Firefox]] or [[Thunderbird]]).}}
  
{{AUR|kgtk}} from the [[AUR]] is a wrapper script which uses {{ic|LD_PRELOAD}} to force KDE file dialogs in GTK+ 2.x apps. Once installed you can run GTK+ 2.x applications with {{ic|kgtk-wrapper}} in two ways (using [[Gimp]] in the examples):
+
{{AUR|kgtk}} from the [[AUR]] is a wrapper script which uses {{ic|LD_PRELOAD}} to force KDE file dialogs in GTK+ 2.x apps. Once installed you can run GTK+ 2.x applications with {{ic|kgtk-wrapper}} in two ways (using [[GIMP]] in the examples):
  
 
* Calling {{ic|kgtk-wrapper}} directly and using the GTK+ 2.x binary as an argument:
 
* Calling {{ic|kgtk-wrapper}} directly and using the GTK+ 2.x binary as an argument:
Line 83: Line 102:
 
=== Using a GTK+ icon theme in Qt apps ===
 
=== Using a GTK+ icon theme in Qt apps ===
  
If running [[KDE]], install {{Pkg|kde-gtk-config}} and select the icon-theme under ''System Settings > Application Style > GTK''.
+
{{Style|Duplicates [[environment variables]]}}
 +
 
 +
If you are running Plasma, install {{Pkg|kde-gtk-config}} and select the icon-theme under ''System Settings > Application Style > GTK''.
 +
 
 +
If you are using [[GNOME]], first check if {{Pkg|dconf-editor}} is installed.
 +
 
 +
Then, run {{ic|dconf-editor}} and look under ''org > gnome > desktop > interface'' for {{ic|icon-theme}} key and change it to your preferred icon theme.  
  
If you are not using [[GNOME]], run {{ic|gconf-editor}}, look under ''desktop > gnome > interface'' for the {{ic|icon_theme}} key and change it to your preference. As you are not using GNOME, it is possible that you will have to set {{ic|1=export DESKTOP_SESSION=gnome}} somewhere in your {{ic|~/.xinitrc}} or, if you are using [[LightDM]], in {{ic|/etc/environment}}.
+
If you are not using [[GNOME]], for example if you are running a minimal system with {{Pkg|i3-wm}}, first install {{Pkg|dconf-editor}}.
 +
 
 +
Then, run {{ic|dconf-editor}} and look under ''org > gnome > desktop > interface'' for {{ic|icon-theme}} key and change it to your preferred icon theme.  
 +
 
 +
Since, you are not using [[GNOME]], you might have to set the value of {{ic|DESKTOP_SESSION}} in your profile. To do that execute the below code in a terminal and restart your system.
 +
 
 +
$ echo 'export DESKTOP_SESSION=gnome' >> /etc/profile
 +
 
 +
'''OR'''
 +
 
 +
Set {{ic|1=export DESKTOP_SESSION=gnome}} somewhere in your {{ic|~/.xinitrc}} or, if you are using a [[Display manager]] in [[Xprofile]].
 +
 
 +
{{Note| If the icon theme was not applied, you might want to check if the name that you entered of your preferred theme, was in the correct format. For example, if you want to apply the currently active icon theme to your QT applications, you can find the correct format of it's name with the command:
 +
 
 +
{{bc|1=$ cat ~/.gtkrc-2.0 {{!}} grep icon-theme {{!}} cut -d= -f2}}
 +
 
 +
}}
  
 
=== Improve subpixel rendering of GTK apps under KDE Plasma ===
 
=== Improve subpixel rendering of GTK apps under KDE Plasma ===
Line 94: Line 135:
  
 
=== Qt applications do not use QGtkStyle ===
 
=== Qt applications do not use QGtkStyle ===
Qt will not apply QGtkStyle correctly if GTK+ is using the [[#GTK+-Qt Engine|GTK+-Qt Engine]]. Qt determines whether the GTK+-Qt Engine is in use by reading the GTK+ configuration files listed in the environmental variable {{ic|GTK2_RC_FILES}}. If the environmental variable is not set properly, Qt assumes you are using the engine, sets QGtkStyle to use the style GTK+ style ''Clearlooks'', and outputs an error message:
+
Qt will not apply QGtkStyle correctly if GTK+ is using the [[#GTK+-Qt Engine|GTK+-Qt Engine]]{{Broken section link}}. Qt determines whether the GTK+-Qt Engine is in use by reading the GTK+ configuration files listed in the environmental variable {{ic|GTK2_RC_FILES}}. If the environmental variable is not set properly, Qt assumes you are using the engine, sets QGtkStyle to use the style GTK+ style ''Clearlooks'', and outputs an error message:
  
 
  QGtkStyle cannot be used together with the GTK_Qt engine.
 
  QGtkStyle cannot be used together with the GTK_Qt engine.
Line 102: Line 143:
 
  QGtkStyle was unable to detect the current GTK+ theme.
 
  QGtkStyle was unable to detect the current GTK+ theme.
  
According to [https://bbs.archlinux.org/viewtopic.php?id=99175&p=1 this thread], you may simply have to install {{Pkg|libgnomeui}} to solve this issue. This has the added benefit that you do not need to edit a file every time you change your theme via a graphical tool, like the one provided by xfce.
+
According to [https://bbs.archlinux.org/viewtopic.php?id=99175&p=1 this thread], you may simply have to install {{AUR|libgnomeui}} to solve this issue. This has the added benefit that you do not need to edit a file every time you change your theme via a graphical tool, like the one provided by xfce.
  
 
Users of [[Openbox]] and other non-GNOME environments may encounter this problem. To solve this, first add the following to your {{ic|.xinitrc}} file:
 
Users of [[Openbox]] and other non-GNOME environments may encounter this problem. To solve this, first add the following to your {{ic|.xinitrc}} file:
Line 117: Line 158:
 
}}
 
}}
  
Then specify the theme you want in the {{ic|~/.gtkrc-2.0}} file using a [[#GTK2 styles|dedicated application]] or manually, by adding:
+
Then specify the theme you want in the {{ic|~/.gtkrc-2.0}} file using a [[#GTK2 styles|dedicated application]]{{Broken section link}} or manually, by adding:
 
{{hc|.gtkrc-2.0|<nowiki>
 
{{hc|.gtkrc-2.0|<nowiki>
 
...
 
...
Line 159: Line 200:
 
Usually the expected files should be {{ic|~/.gtkrc}} for GTK1 and {{ic|~/.gtkrc2.0}} or {{ic|~/.gtkrc2.0-kde}} for GTK+ 2.x.
 
Usually the expected files should be {{ic|~/.gtkrc}} for GTK1 and {{ic|~/.gtkrc2.0}} or {{ic|~/.gtkrc2.0-kde}} for GTK+ 2.x.
  
Newer versions of {{AUR|gtk-qt-engine}}{{Broken package link|{{aur-mirror|gtk-qt-engine}}}} use {{ic|~/.gtkrc2.0-kde}} and set the export variable in {{ic|~/.kde/env/gtk-qt-engine.rc.sh}}.
+
=== GTK+ apps don't use svg (breeze) icons after system upgrade ===
If you recently removed '''gtk-qt-engine''' and are trying to set a GTK+ theme then you must also remove {{ic|~/.kde/env/gtk-qt-engine.rc.sh}} and reboot. Doing this will ensure that GTK+ looks for its settings in the standard {{ic|~/.gtkrc2.0}} instead of the {{ic|~/.gtkrc2.0-kde}} file.
+
 
 +
Try to run this to fix this issue:
 +
# gdk-pixbuf-query-loaders --update-cache

Revision as of 19:56, 7 February 2018

Qt and GTK+ based programs both use a different widget toolkit to render the graphical user interface. Each come with different themes, styles and icon sets by default, among other things, so the "look and feel" differ significantly. This article will help you make your Qt and GTK+ applications look similar for a more streamlined and integrated desktop experience.

Overview

To get a similar look between the toolkits, you will most likely have to modify the following:

  • Theme: The custom appearance of an application, widget set, etc. It usually consists of a style, an icon theme and a color theme.
  • Style: The graphical layout and look of the widget set.
  • Icon Theme: A set of global icons.
  • Color Theme: A set of global colors that are used in conjunction with the style.

You can choose various approaches:

  • Modify GTK+ and Qt styles separately with the tools listed below for each toolkit and aim for choosing similarly looking themes (style, colors, icons, cursors, fonts).
  • Use a special theme engine, which intermediates the modification of the other graphical toolkit to match your main toolkit.

Styles for both Qt and GTK+

There are widget style sets available for the purpose of integration, where builds are written and provided for both Qt and GTK+, all major versions included. With these, you can have one look for all applications regardless of the toolkit they had been written with.

Tip: You may want to apply user defined styles to root applications, see GTK#Theme not applied to root applications and Qt#Theme not applied to root applications.
Note: Since version 3.16, GTK+ 3 does not support non-CSS themes, hence previous solutions such as Oxygen-Gtk are no longer viable options.

Breeze

Breeze is the default Qt style of KDE Plasma. It can be installed with the breeze package for Qt5, the breeze-kde4 package for Qt4, and the breeze-gtk package for GTK+ 2 and GTK+ 3.

Once installed, you can use one of the many GTK+ configuration tools to change the GTK+ theme.

Adwaita

Adwaita is the default GNOME theme. The GTK+ 3 version is included in the gtk3 package, while the GTK+ 2 version is in gnome-themes-standard. adwaita-qt is a Qt port of the Adwaita theme. Unlike #QGtkStyle, which mimics the GTK+ 2 theme, it provides a native Qt style made to look like the GTK+ 3 Adwaita. It can be installed with the adwaita-qt4AUR and adwaita-qt5AUR packages for the Qt 4 and 5 versions, respectively.

To set the Qt style as default:

  • For Qt4, it can be enabled with Qt Configuration (qtconfig-qt4), choose adwaita under Appearance > GUI Style. Alternatively, edit the /etc/xdg/Trolltech.conf (system-wide) or ~/.config/Trolltech.conf (user-specific) file:
~/.config/Trolltech.conf
...
[Qt]
style=adwaita
...

Theme engines

A theme engine can be thought of as a thin layer API which translates themes (excluding icons) between one or more toolkits. These engines add some extra code in the process and it is arguable that this kind of a solution is not as elegant and optimal as using native styles.

QGtkStyle

Note: QGtkStyle has been removed from qt5-base 5.7.0 [1] and added to qt5-styleplugins [2]
Warning: Depending on GTK+ 2 theme, this style may cause rendering issues such as transparent fonts or inconsistent widgets.

This Qt style uses GTK+ 2 to render all components to blend in with GNOME and similar GTK+ based environments. Beginning with Qt 4.5, this style is included in Qt. It requires gtk2 to be installed and configured.

This is the default Qt4 style in Cinnamon, GNOME and Xfce, and the default Qt5 style in Cinnamon, GNOME, MATE, LXDE and Xfce. In other environments:

  • For Qt4, it can be enabled with Qt Configuration (qtconfig-qt4), choose GTK+ under Appearance > GUI Style. Alternatively, edit the /etc/xdg/Trolltech.conf (system-wide) or ~/.config/Trolltech.conf (user-specific) file:
~/.config/Trolltech.conf
...
[Qt]
style=GTK+
...

For full uniformity, make sure that the configured GTK+ theme supports both GTK+ 2 and GTK+ 3. If your preferred theme has inconsistent rendering after configuring Qt to use GTK+2, install gtk-theme-switch2 and choose a theme.

QGnomePlatform

This Qt 5 platform theme applies the appearance settings of GNOME for Qt applications. It can be installed with the qgnomeplatformAUR package or the qgnomeplatform-gitAUR package for the development version. It does not provide a Qt style itself, instead it requires a style that support both Qt and GTK+.

This platform theme is enabled automatically in GNOME since version 3.20. For other systems, it can be enabled by setting the following environment variable: QT_QPA_PLATFORMTHEME=qgnomeplatform.

Tips and tricks

KDE file dialogs for GTK+ applications

Chromium At least for chromium installing kdialog makes chromium used kde file dialog ( so `KGtk-wrapper` is not required )

Warning: Some GTK+ applications may not be compatible with KGtk-wrapper (e.g. Chromium), sometimes the wrapper makes the application crash (Firefox or Thunderbird).

kgtkAUR from the AUR is a wrapper script which uses LD_PRELOAD to force KDE file dialogs in GTK+ 2.x apps. Once installed you can run GTK+ 2.x applications with kgtk-wrapper in two ways (using GIMP in the examples):

  • Calling kgtk-wrapper directly and using the GTK+ 2.x binary as an argument:
$ /usr/bin/kgtk-wrapper gimp
  • Modifying the KDE .desktop shortcuts files you can find at /usr/share/applications/ to prefix the Exec statement with kgtk-wrapper.
e.g. with GIMP, edit the /usr/share/applications/gimp.desktop shortcut file and replace Exec=gimp-2.8 %U by Exec=kgtk-wrapper gimp-2.8 %U.

Using a GTK+ icon theme in Qt apps

Tango-edit-clear.pngThis article or section needs language, wiki syntax or style improvements.Tango-edit-clear.png

If you are running Plasma, install kde-gtk-config and select the icon-theme under System Settings > Application Style > GTK.

If you are using GNOME, first check if dconf-editor is installed.

Then, run dconf-editor and look under org > gnome > desktop > interface for icon-theme key and change it to your preferred icon theme.

If you are not using GNOME, for example if you are running a minimal system with i3-wm, first install dconf-editor.

Then, run dconf-editor and look under org > gnome > desktop > interface for icon-theme key and change it to your preferred icon theme.

Since, you are not using GNOME, you might have to set the value of DESKTOP_SESSION in your profile. To do that execute the below code in a terminal and restart your system.

$ echo 'export DESKTOP_SESSION=gnome' >> /etc/profile

OR

Set export DESKTOP_SESSION=gnome somewhere in your ~/.xinitrc or, if you are using a Display manager in Xprofile.

Note: If the icon theme was not applied, you might want to check if the name that you entered of your preferred theme, was in the correct format. For example, if you want to apply the currently active icon theme to your QT applications, you can find the correct format of it's name with the command:
$ cat ~/.gtkrc-2.0 | grep icon-theme | cut -d= -f2

Improve subpixel rendering of GTK apps under KDE Plasma

See Font configuration#LCD filter.

Troubleshooting

Qt applications do not use QGtkStyle

Qt will not apply QGtkStyle correctly if GTK+ is using the GTK+-Qt Engine[broken link: invalid section]. Qt determines whether the GTK+-Qt Engine is in use by reading the GTK+ configuration files listed in the environmental variable GTK2_RC_FILES. If the environmental variable is not set properly, Qt assumes you are using the engine, sets QGtkStyle to use the style GTK+ style Clearlooks, and outputs an error message:

QGtkStyle cannot be used together with the GTK_Qt engine.

Another error you may get after launching qtconfig-qt4 from a shell and selecting the GTK+ style is:

QGtkStyle was unable to detect the current GTK+ theme.

According to this thread, you may simply have to install libgnomeuiAUR to solve this issue. This has the added benefit that you do not need to edit a file every time you change your theme via a graphical tool, like the one provided by xfce.

Users of Openbox and other non-GNOME environments may encounter this problem. To solve this, first add the following to your .xinitrc file:

.xinitrc
...
export GTK2_RC_FILES="$HOME/.gtkrc-2.0"
...
Note:
  • Make sure to add this line before invoking the window manager.
  • You can add multiple paths by separating them with colons.
  • Make sure to use $HOME instead of ~ as it will not properly expand to the user's home directory.

Then specify the theme you want in the ~/.gtkrc-2.0 file using a dedicated application[broken link: invalid section] or manually, by adding:

.gtkrc-2.0
...
gtk-theme-name="[name of theme]"
...

Some tools only insert the following include directive in ~/.gtkrc-2.0:

.gtkrc-2.0
...
include "/usr/share/themes/SomeTheme/gtk-2.0/gtkrc"
...

which apparently is not recognized by all versions of QGtkStyle. You can hotfix this problem by inserting the gtk-theme-name manually in your ~/.gtkrc-2.0 file like above.

Note: Style-changing applications will most probably rewrite the ~/.gtkrc-2.0 file the next time you change themes.

If these steps do not work, install gconf and run this command:

gconftool-2 --set --type string /desktop/gnome/interface/gtk_theme [name of theme]

If you further want to set the same icon and cursor theme, then you have to specify them, too.

gconftool-2 --set --type string /desktop/gnome/interface/icon_theme Faenza-Dark

This sets the icon theme to Faenza-Dark located in /usr/share/icons/Faenza-Dark. For the cursor theme you first have to set the gconf value.

gconftool-2 --set --type string /desktop/gnome/peripherals/mouse/cursor_theme Adwaita

Then you will have to create the file /usr/share/icons/default/index.theme with the following lines:

[Icon Theme]
Inherits=Adwaita

Themes not working in GTK+ apps

If the style or theme engine you set up is not showing in your GTK applications then it is likely your GTK+ settings files are not being loaded for some reason. You can check where your system expects to find these files by doing the following..

$ export | grep gtk

Usually the expected files should be ~/.gtkrc for GTK1 and ~/.gtkrc2.0 or ~/.gtkrc2.0-kde for GTK+ 2.x.

GTK+ apps don't use svg (breeze) icons after system upgrade

Try to run this to fix this issue:

# gdk-pixbuf-query-loaders --update-cache